unit frmPhotozouUploadU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, shellapi,
  photozou_api, IdComponent;

type
  TfrmPhotozouUpload = class(TForm)
    pcUpload: TPageControl;
    tabLogin: TTabSheet;
    tabUpload: TTabSheet;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    lblLinkPhotozou: TLabel;
    Label4: TLabel;
    Panel2: TPanel;
    Label3: TLabel;
    Label5: TLabel;
    edtID: TEdit;
    edtPassword: TEdit;
    btnLogin: TButton;
    Panel3: TPanel;
    Label6: TLabel;
    cmbAlbum: TComboBox;
    Label7: TLabel;
    edtFile: TEdit;
    btnSelFile: TButton;
    dlgOpen: TOpenDialog;
    btnUpload: TButton;
    Label8: TLabel;
    edtTitle: TEdit;
    tabInfo: TTabSheet;
    Panel4: TPanel;
    Label9: TLabel;
    edtURL: TEdit;
    btnOpen: TButton;
    Label10: TLabel;
    btnClose: TButton;
    btnCopy: TButton;
    bar: TProgressBar;
    procedure lblLinkPhotozouClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnLoginClick(Sender: TObject);
    procedure edtIDKeyPress(Sender: TObject; var Key: Char);
    procedure edtPasswordKeyPress(Sender: TObject; var Key: Char);
    procedure btnSelFileClick(Sender: TObject);
    procedure btnUploadClick(Sender: TObject);
    procedure btnOpenClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnCopyClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private 錾 }
    bLogin:Boolean;
    procedure onWorkBegin(Sender: TObject; AWorkMode: TWorkMode;
      const AWorkCountMax: Integer);
    procedure onWork(Sender: TObject; AWorkMode: TWorkMode; const AWorkCount: Integer);

  public
    { Public 錾 }
    api: TPhotozouApi;
  end;

var
  frmPhotozouUpload: TfrmPhotozouUpload;

implementation

uses unit_string;


{$R *.dfm}

procedure TfrmPhotozouUpload.lblLinkPhotozouClick(Sender: TObject);
begin
  ShellExecute(Self.Handle, 'open', 'http://photozou.jp/', nil, nil, SW_SHOW);
end;

procedure TfrmPhotozouUpload.FormCreate(Sender: TObject);
begin
  api := nil;
  bLogin := False;
  pcUpload.ActivePage  := tabLogin;
  tabLogin.TabVisible  := True;
  tabUpload.TabVisible := False;
  tabInfo.TabVisible   := False;
end;

procedure TfrmPhotozouUpload.FormShow(Sender: TObject);
begin
  if api = nil then
  begin
    api := TPhotozouApi.Create(Self);
  end;
  if bLogin = False then
  begin
    pcUpload.ActivePage  := tabLogin;
    edtID.SetFocus;
  end else
  begin
    pcUpload.ActivePage  := tabUpload;
  end;
  bar.Position := 0;
end;

procedure TfrmPhotozouUpload.FormDestroy(Sender: TObject);
begin
  FreeAndNil(api);
end;

procedure TfrmPhotozouUpload.btnLoginClick(Sender: TObject);
begin
  btnLogin.Enabled := False;
  try
    api.UserAddress  := edtID.Text;
    api.UserPassword := edtPassword.Text;
    if not api.CheckAuth then
    begin
      ShowMessage('OCɎs܂B');
      Exit;
    end else
    begin
      cmbAlbum.Items.Text := api.GetPhotoAlbumList;
      if cmbAlbum.Items.Count = 0 then
      begin
        ShowMessage('Ao擾ł܂BT[o[ł\܂B');
        Exit;
      end;
      cmbAlbum.ItemIndex  := 0;
      tabUpload.TabVisible := True;
      pcUpload.ActivePage := tabUpload;
      bLogin := True;
    end;
  finally
    btnLogin.Enabled := True;
  end;
end;

procedure TfrmPhotozouUpload.edtIDKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    edtPassword.SetFocus;
    Key := #0;
  end;
end;

procedure TfrmPhotozouUpload.edtPasswordKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key = #13 then
  begin
    btnLogin.SetFocus;
    Key := #0;
  end;
end;

procedure TfrmPhotozouUpload.btnSelFileClick(Sender: TObject);
begin
  if not dlgOpen.Execute then Exit;
  edtFile.Text := dlgOpen.FileName;
  if edtTitle.Text = '' then
  begin
    edtTitle.Text := ChangeFileExt(ExtractFileName(edtFile.Text),'');
  end;
end;

procedure TfrmPhotozouUpload.btnUploadClick(Sender: TObject);
var
  album_id:Integer;
  s: string;
begin
  if cmbAlbum.ItemIndex < 0 then
  begin
    ShowMessage('AoIĂ');
    Exit;
  end;
  s := cmbAlbum.Items.Strings[ cmbAlbum.ItemIndex ];
  s := getToken_s(s, ',');
  album_id := StrToIntDef(s, 0);

  api.OnWorkBegin := onWorkBegin;
  api.OnWork      := onWork;

  btnUpload.Enabled := False;
  try
    if api.UploadPhoto(edtFile.Text, album_id, edtTitle.Text) then
    begin
      edtUrl.Text := 'http://photozou.jp/photo/show/' + IntToStr(api.user_id) +
        '/' + IntToStr(api.photo_id);
      tabInfo.TabVisible := True;
      pcUpload.ActivePage := tabInfo;
    end else
    begin
      ShowMessage('Abv[hɎs܂B'#13#10 + api.ErrorMessage);
    end;
  finally
    bar.Position := 0;
    btnUpload.Enabled := True;
  end;
end;

procedure TfrmPhotozouUpload.btnOpenClick(Sender: TObject);
var
  url: string;
begin
  url := edtUrl.Text;
  ShellExecute(Self.Handle, 'open', PChar(url), nil, nil, SW_SHOW);
  
end;

procedure TfrmPhotozouUpload.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmPhotozouUpload.btnCopyClick(Sender: TObject);
begin
  edtUrl.SetFocus;
  edtUrl.SelectAll;
  edtUrl.CopyToClipboard;
end;

procedure TfrmPhotozouUpload.onWorkBegin(Sender: TObject;
  AWorkMode: TWorkMode; const AWorkCountMax: Integer);
begin
  bar.Max := AWorkCountMax;
  bar.Position := 0;
end;

procedure TfrmPhotozouUpload.onWork(Sender: TObject; AWorkMode: TWorkMode;
  const AWorkCount: Integer);
begin
  bar.Position := AWorkCount;
end;

procedure TfrmPhotozouUpload.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  edtFile.Text := '';
  edtTitle.Text := '';
  tabInfo.TabVisible := False;
end;

end.
