unit jconvertex;

// lhl̍jbgł
// http://member.nifty.ne.jp/m-and-i/tips/jconex.htm QƁFӁI
// ꕔ NWs(2005/01/28)

interface

uses
  Windows, SysUtils, jconvert, Classes;

const
  UNILE_IN   = 7; // Unicode Little Endian(Intel CPU)
  UNIBE_IN   = 8; // Unicode Big Endian
  UTF8_IN    = 9; // UTF8(TTF8NBOMt)
  UTF8N_IN   = 10;// UTF8N

  UNILE_OUT  = 7;
  UNIBE_OUT  = 8;
  UTF8_OUT   = 9;
  UTF8N_OUT  = 10;

// gR[h`FbN
function InCodeCheckEx(const s: string): integer;
// UNICODE(Little Endian)SJISɕϊ
function uniLETosjis(const s: PWideChar): string;
function uniLETosjis2(const s: string): string; // ^ŗ^ꂽUNICODEsjisɕϊ
// UNICODE(Big Endian)SJISɕϊ
function uniBETosjis(const s: PWideChar): string;
function uniBETosjis2(const s: string): string;
// UTF8SJISɕϊ
function Utf8Tosjis(const s: String): string;
// UTF8NSJISɕϊ
function Utf8NTosjis(const s: String): string;

// SJISUNICODE(LE)ɕϊ
procedure sjisToUniLE(var ms: TMemoryStream; const s: string);
function sjisToUniLE2(const s: string): string;
// SJISUNICODE(BE)ɕϊ
procedure sjisToUniBE(var ms: TMemoryStream; const s: string);
function sjisToUniBE2(const s: string): string;
// SJISUNICODE(UTF8)ɕϊ
function sjisToUtf8(const s: string): string;
// SJISUNICODE(UTF8N)ɕϊ
function sjisToUtf8N(const s: string): string;


implementation

// gR[h`FbN
// UNICODEUTF8`FbNÂǂłȂꍇɂ
// jconvertInCodeCheck߂lɂ
(*
function InCodeCheckEx(const s: string): integer;
var
  index, c, size: Integer;
  utfk: Boolean;
begin
  size := Length(s);
  { Size = 0 }
  if size = 0 then
  begin
    Result := BINARY;
    Exit;
  end;
  { Unicode`FbN }
  { 擪BOM`FbNĂȂ̂Ō쓮̉\ }
  if (size >= 2 ) then
  begin
    { UNICODE(Little Endian)`FbN }
    if (s[1] = #$FF) and (s[2] = #$FE) then
    begin
      Result := UNILE_IN;
      Exit;
    end;
    { UNICODE(Big Endian)`FbN }
    if (s[1] = #$FE) and (s[2] = #$FF) then
    begin
      Result := UNIBE_IN;
      Exit;
    end;
  end;
  { UTF-8`FbN }
  if size > 3 then
  begin
    { UTF-8N(BOM)`FbN }
    { 擪BOM`FbNĂȂ̂Ō쓮̉\ }
    if (s[1] = #$EF) and (s[2] = #$BB) and (s[3] = #$BF) then
    begin
      Result := UTF8_IN;
      Exit;
    end;
  end;
  {UTF-8(BOMȂ)`FbN}
  index := 1;
  utfk := False;
  while (index <= STRICT_CHECK_LEN) and (index < size - 4) do
  begin
    c := Ord(s[index]);
    if (c in [$C0..$DF]) or (c > $EF) then
    begin
      utfk := False;
      Break;
    end;
    if c in [0..$7F] then
    begin
      ;
    end else if c = $E0 then
    begin
      Inc(index);
      c := Ord(s[index]);
      if c in [$A0..$BF] then
      begin
        Inc(index);
        c := Ord(s[index]);
        if c in [$80..$BF] then
          utfk := True
        else begin
          utfk := False;
          Break;
        end;
      end else begin
        utfk := False;
        Break;
      end;
    end else if c in [$E1..$EF] then
    begin
      Inc(index);
      c := Ord(s[index]);
      if c in [$80..$BF] then
      begin
        Inc(index);
        c := Ord(s[index]);
        if c in [$80..$BF] then
          utfk := True
        else begin
          utfk := False;
          Break;
        end;
      end else begin
        utfk := False;
        Break;
      end;
    end else begin
      utfk := False;
      Break;
    end;
    Inc(index);
  end;
  { UTF }
  if utfk then
    Result := UTF8N_IN
  { UnicdełUTF8łȂJconvertŃ`FbN }
  else
    Result := InCodeCheck(s);
end;
*) // {Ƃ̃`FbN

//NW`FbN
//ȉ̂vdaQlɂ
//http://www.gprj.net/dev/tips/other/kanji.shtml

function InCodeCheckEx(const s: string): Integer;
var
  i, rMax, rMaxV, maxLen, sLen: Integer;
  FlagUTF8Bom: Boolean;
  FlagStrict: Boolean; // R[hm肵ǂ
  rate: array [0..10] of Integer;

  procedure IncRate(code, v: Integer);
  begin
    rate[code] := rate[code] + v;
  end;

  procedure check_ISO2022JP;
  begin
    // ISO-2022-JP̃`FbN
    { 1    2    3
      0x1B 0x24 0x40       JIS X 0208-1978
      0x1B 0x24 0x42       JIS X 0208-1983
      0x1B 0x24 0x28 0x44  JIS X 0208-1990
      0x1B 0x24 0x28 0x4F  JIS X 0213:2000 1
      0x1B 0x24 0x28 0x50  JIS X 0213:2000 2
      0x1B 0x24 0x42       JIS X 0208-1990
      0x1B 0x26 0x40       JIS X 0208-1990
      0x1B 0x28 0x49       JIS X 0201-1976 Љ
      0x1B 0x28 0x42       ASCII
      0x1B 0x28 0x4A       JIS X 0201-1976 Roman Set
      0x1B 0x28 0x48       JIS X 0201-1976 Roman Set
    }

    if (i+3) <= slen then
    begin

      if s[i] = #$1B{ESC} then
      begin
        case s[i+1] of
          #$24:
            begin
              case s[i+2] of
                #$40: Result := JIS78_IN;
                #$42: Result := JIS83_IN;
                #$44: Result := JIS83_IN; // { JIS90 
                else  Result := JIS83_IN;
              end;
            end;
          #$28:
            begin
              Result := JIS78_IN; // { JIS76 
            end;
          #$26:
            begin
              Result := JIS83_IN; // { JIS90 
            end;
          else
            begin
              FlagStrict := True;
              Exit;
            end;
        end;
        FlagStrict := True;
      end;

    end;
  end;

  procedure check_UTF8;
  var
    cb: Byte;
    temp: Integer;

    function chk(count: Integer): Boolean;
    var k: Integer; b: Byte;
    begin
      Result := False;
      if (i+count) > slen then Exit;
      // check
      for k := 1 to count do
      begin
        b := Ord(s[i + k]);
        if not ( ($80 <= b) and (b <= $BF) ) then
        begin
          rate[UTF8N_IN] := 0; // \Ⴂ
          Exit; // False
        end;
      end;
      // ok
      Result := True;
      Exit;
    end;

  begin
    // UTF-8 ̃`FbN
    if not( (#$C0 <= s[i])and(s[i] <= #$FD) ) then Exit; // \Ȃ

    temp := i;

    // BOMH
    if Copy(s, i, 3) = #$EF+#$BB+#$BF then
    begin
      FlagUTF8Bom := True;
      Inc(i, 3);
      if i > sLen then Exit; // FALSE
    end;

    // UTF-8 ̂PoCg()
    // 1oCg0xC0<->0xFDłUTF-8̋\
    // 2oCgȍ~w肳ꂽTCY0x80<->0xBF͈͓̔ǂ`FbN
    // 2oCgȍ~́A0x80<->0xBF ɂȂ
    {
    AND 0xFC ... 5oCg(RFC2279(jRFC))
    AND 0xF8 ... 4oCg
    AND 0xF0 ... 3oCg
    AND 0xE0 ... 2oCg
    AND 0xC0 ... 1oCg(擪oCg킷)
    }

    while i <= maxLen do // JԂ\`FbN
    begin
      IncRate(UTF8N_IN, 1); //

      // 1oCgڂ`FbN
      cb := Ord(s[i]);
      if (cb and $FC) = $FC then
      begin
        if chk(5) = False then Exit; // False
        Result := UTF8N_IN;
        Inc(i); Inc(i, 5);
      end else
      if (cb and $F8) = $F8 then
      begin
        if chk(4) = False then Exit; // False
        Result := UTF8N_IN;
        Inc(i); Inc(i, 4);
      end else
      if (cb and $F0) = $F0 then
      begin
        if chk(3) = False then Exit; // False
        Result := UTF8N_IN;
        Inc(i); Inc(i, 3);
      end else
      if (cb and $E0) = $E0 then
      begin
        if chk(2) = False then Exit; // False
        Result := UTF8N_IN;
        Inc(i); Inc(i, 2);
      end else
      if (cb and $C0) = $C0 then
      begin
        //if chk(1) = False then Exit; // False
        Result := UTF8N_IN;
        Inc(i); Inc(i);
      end else
      // 1 oCg
      begin
        if cb < $80 then
        begin
          Inc(i);
        end else
        begin
          i := temp;
          FlagStrict := False;
          Exit;
        end;
      end;
    end;
    //
  end;

  procedure check_EUC;
  begin
    { EUC
      1oCg         0xA1<->0xFE
      2oCg         0x8E(1oCg) + 0xA1<->0xDF
      pJi          0xA4(1oCg) + 0xA1<->0xF3
      Sp(`)  0xA5(1oCg) + 0xA1<->0xF6
      SpJi(A`)  0x8F(1oCg) + 0xA1<->0xFE(2E3oCg)
      ⏕ 0xA1<->0xFE
      --------------------
    }
    {
      EUC pJĩ`FbN

    1oCg0x8Eő2oCg0xA1<->0xDFȏꍇEUCpJi̋\
    ɑ̕R[h̋\ƔfĂȂꍇɌ
    2oCgEUCpJi͈͊O0x80<->0xA0łȂSJIS(m)
    ȏɓĂ͂܂Ȃꍇ͕sR[h

    }
    if ((i+2) > slen) then Exit;
    // pJỉ\
    if (s[i] = #$8E) then
    begin
      // SJIS H
      if s[i+1] in [#$80..#$A0] then
      begin
        // SJISm
        Result := SJIS_IN;
        FlagStrict := True;
        Exit;
      end;
      if s[i+1] in [#$A1..#$DF] then // \
      begin
        // EUCJỉ\ ... m肵Ȃ
        Result := EUC_IN;
        IncRate(EUC_IN, 2);
      end;
    end;
    {
    1oCg0x8Fő2E3oCg0xA1<->0xFEȏꍇEUC⏕̋\
    ɑ̕R[h̋\ƔfĂȂꍇɌ
    2E3oCgǂ炩0xFDE0xFEłȂEUC⏕(m)
    2E3oCgEUC⏕͈͊O0x80<->0xA0łȂSJIS(m)
    ȏɓĂ͂܂Ȃꍇ͕sR[h
    }
    // dtb⏕̉\
    if (s[i] = #$8F)and((i+3) <= slen) then
    begin
      if (s[i+1] in [#$A1..#$FE])and((s[i+2] in [#$A1..#$FE])) then
      begin
        Result := EUC_IN; // EUC̉\
        IncRate(EUC_IN,1);

        // m肷邩H
        if (s[i+1] in [#$FD,#$FE]) or (s[i+2] in [#$FD,#$FE]) then
        begin
          FlagStrict := True; Exit;
        end;
      end;
    end;
    //

  end;

  procedure check_SJIS;
  begin
    // SJIS
    // 0x80<->0xA0łȂSJISŊm
    if s[i] in [#$80..#$A0] then
    begin
      FlagStrict := True;
      Result := SJIS_IN;
      Exit;
    end;
    {
    0xA1<->0xDFoꍇSJISpJiEEUCSpȁEJi̋\
    ɑ̕R[h̋\ƔfĂȂꍇɌ
    1oCg0xA40xA5ő2oCg[]0xA1<->0xF3[Ji]0xA1<->0xF6łȂ
    EUCSpЂ炪ȁEJ^Ji̎ア\
    2oCg`FbN0xE0<->0xFEłȂEUC̋\0xFDE0xFȄꍇEUC(m)
    2oCg݂ȂꍇSJIS̋\
    ȏɓĂ͂܂ȂꍇSJISpJi̋\
    }
    if (i+1) > slen then
    begin
      // QoCg݂Ȃ
      if s[i] in [#$A1..#$DF] then
      begin
        Result := SJIS_IN; FlagStrict := True; // pJiŌ
      end;
      Exit;
    end;
    // SJIS pJi̔
    if s[i] in [#$A1..#$DF] then // SJISpJi or EUCSpȁEJỉ\
    begin
      IncRate(SJIS_IN, 1);
      if (s[i] in [#$A4,#$A5])and(s[i+1] in [#$A1..#$F6]) then // EUCSpЂ炪ȁEJ^Ji̎ア\
      begin
        IncRate(EUC_IN,1);
      end else
      if s[i+1] in [#$E0..#$FE] then //EUC̋\
      begin
        IncRate(EUC_IN,2);
        Result := EUC_IN;
        if s[i+1] in [#$FD,#$FE] then
        begin
          FlagStrict := True; Exit;
        end;
      end else
      begin
        IncRate(SJIS_IN,1);
        Result := SJIS_IN; // \
      end;
    end;
  end;

  procedure check_UNICODE;
  begin
    { Unicode`FbN }
    { 擪BOM`FbNĂȂ̂Ō쓮̉\ }
    if (sLen >= 2 ) then
    begin
      { UNICODE(Little Endian)`FbN }
      if (s[1] = #$FF) and (s[2] = #$FE) then
      begin
        Result := UNILE_IN;
        FlagStrict := True;
      end;
      { UNICODE(Big Endian)`FbN }
      if (s[1] = #$FE) and (s[2] = #$FF) then
      begin
        Result := UNIBE_IN;
        FlagStrict := True;
      end;
    end;
  end;

begin
  Result := BINARY;
  if s = '' then Exit;

  // ݒ
  maxLen := Length(s);
  sLen   := maxLen;
  if maxLen > STRICT_CHECK_LEN then maxLen := STRICT_CHECK_LEN;
  FlagUTF8Bom := False;
  FlagStrict  := False; // R[hm肵ǂ


  // UNICODE ͎̔蔲
  check_UNICODE;

  // SASCIIH
  FlagStrict := True;
  for i := 1 to maxLen do
  begin
    if not(Ord(s[i]) in [$21..$7E]) then
    begin
      FlagStrict := False;
      Break;
    end;
  end;
  if FlagStrict then
  begin
    Result := ASCII; Exit;
  end;


  // {iJn
  FlagStrict := False;
  for i := 0 to High(rate) do
  begin
    rate[i] := 0;
  end;
  
  i := 1;
  while i <= maxLen do
  begin
    // JIS ͊m肷
    check_ISO2022JP;
    if FlagStrict then Exit;

    // UTF-8/UTF-8N
    check_UTF8;

    // UNICODE
    check_UNICODE;
    if FlagStrict then Exit;

    // EUCJiE⏕
    check_EUC;
    if FlagStrict then Exit;

    // SJIS
    check_SJIS;
    if FlagStrict then Exit;

    // EUC
    {0xA1<->0xFȄꍇEUC̋\0xFDE0xFȄꍇEUC(m)}
    if s[i] in [#$A1..#$FE] then
    begin
      Result := EUC_IN;
      IncRate(EUC_IN,2);
      if s[i] in [#$FD,#$FE] then Exit; // EUCm
    end;

    Inc(i);
  end;

  // ŉ\eXg
  // \܂܂Ō肵Ȃꍇ
  // Ԋm̗̂p
  rMax := ASCII; rMaxV := 0;
  for i := 2 to High(rate) do
  begin
    if rate[i] > rMaxV then
    begin
      rMax := i; rMaxV := rate[i];
    end;
  end;
  Result := rMax;

  if Result = UTF8N_IN then
  begin
    // BOM Ń`FbN
    if FlagUTF8Bom then
    begin
      Result := UTF8_IN;
    end else
    begin
      Result := UTF8N_IN;
    end;
  end;

end;


function UniLETosjis(const s: PWideChar): string;
begin
  Result := WideCharToString(s);
end;

function uniLETosjis2(const s: string): string; // ^ŗ^ꂽUNICODEsjisɕϊ
begin
  if s <> '' then
  begin
    Result := WideCharToString(@s[1]);
  end else
  begin
    Result := '';
  end;
end;

function uniBETosjis2(const s: string): string;
begin
  if s <> '' then
  begin
    Result := UniBETosjis(@s[1]);
  end else
  begin
    Result := '';
  end;
end;


function UniBETosjis(const s: PWideChar): string;
var
  Pc: PChar;
  c: char;
  n: integer;
begin
  Pc := PChar(s);
  n := 0;
  while True do
  begin
    if (Pc[n] = #0) and (Pc[n+1] = #0) then
      Break;
    c := Pc[n];
    Pc[n] := Pc[n+1];
    Pc[n+1] := c;
    Inc(n, 2);
  end;
  Result := WideCharToString(PWideChar(Pc));
end;

procedure sjisToUniLE(var ms: TMemoryStream; const s: string);
var
  PWs: PWideChar;
  Len: integer;
begin
  if not Assigned(ms) then
    raise Exception.Create('MemoryStream.');
  Len := Length(s) * 2;
  PWs := AllocMem(Len + 2);
  try
    StringToWideChar(s, PWs, Len);
    ms.Write(#$FF#$FE, 2);
    ms.Write(PWs^, Length(Pws) * 2);
  finally
    FreeMem(PWs);
  end;
end;

function sjisToUniLE2(const s: string): string;
var
  i, len, sLen: Integer;
begin
  sLen := Length(s);
  len := sLen * 2;
  SetLength(Result, len + 2);
  StringToWideChar(s, @Result[1], len);
  // 𑪂
  len := 2;
  for i := 0 to sLen-1 do
  begin
    if Result[i*2+1] = #0 then // 1 oCgڂ0ȂΏI[
    begin
      len := i*2; Break;
    end;
  end;
  Result := Copy(Result, 1, len);
  Result := #$FF#$FE + Result;
end;

function sjisToUniBE2(const s: string): string;
var
  m: TMemoryStream;
begin
  m := TMemoryStream.Create;
  try
    sjisToUniBe(m, s);
    SetLength(Result, m.Size);
    m.Position := 0;
    if m.Size > 0 then
    begin
      m.Write(Result[1], m.Size);
    end else
    begin
      Result := '';
    end;
  finally
    m.Free;
  end;
end;

procedure sjisToUniBE(var ms: TMemoryStream; const s: string);
var
  PWs: PWideChar;
  Pc: PChar;
  len, n: integer;
  Tc: Char;
begin
  if not Assigned(ms) then
    raise Exception.Create('MemoryStream.');
  Len := Length(s) * 2;
  PWs := AllocMem(Len + 2);
  try
    StringToWideChar(s, PWs, Len);
    Pc := PChar(PWs);
    n := 0;
    while n < len do
    begin
      Tc := (Pc+n)^;
      (Pc+n)^ := (Pc+n+1)^;
      (Pc+n+1)^ := Tc;
      Inc(n, 2);
    end;
    ms.Write(#$FE#$FF, 2);
    ms.Write(PWs^, Length(Pws) * 2);
  finally
    FreeMem(PWs);
  end;
end;

function Utf8NTosjis(const s: string): string;
var
  Len: integer;
  OutStr: PWideChar;
  SIn, SOut: string;
begin
  Result := '';
  // S~h~
  SIn := S + #0#0;
  Len := MultiByteToWideChar(CP_UTF8, 0, PChar(SIn), Length(SIn), nil, 0);
  if Len = 0 then
    raise Exception.Create('UTF8̕ϊɎs܂.');
  // Lenŗǂ͂AȂG[ƂȂ邽߂Q{
  OutStr := AllocMem(Len * 2);
  try
    MultiByteToWideChar(CP_UTF8, 0, PChar(SIn), Length(SIn), OutStr, Len);
    WideCharToStrVar(OutStr, SOut);
    Result := SOut;
  finally
    FreeMem(OutStr);
  end;
end;

function Utf8Tosjis(const s: string): string;
var
  s2: string;
begin
  s2 := s;
  // #$EF#$BB#$BF邩
  if Copy(s2,1,3) = #$EF#$BB#$BF then
  begin
    Delete(s2, 1, 3);
  end;
  Result := Utf8NTosjis(s2);
end;

function SjisToUtf8N(const s: string): string;
var
  Len: integer;
  InStr: PWideChar;
  OutStr: PChar;
begin
  Result := '';
  Len := Length(s) * 2 + 2;
  InStr := AllocMem(Len);
  try
    StringToWideChar(s, InStr, Len);
    OutStr := AllocMem(Len);
    try
      WideCharToMultiByte(CP_UTF8, 0, InStr, Length(InStr) * 2, OutStr, Len, nil, nil);
      Result := OutStr;
    finally
      FreeMem(OutStr);
    end;
  finally
    FreeMem(InStr);
  end;
end;

function SjisToUtf8(const s: string): string;
begin
  Result := #$EF#$BB#$BF + SjisToUtf8N(s);
end;

end.

