unit frmApiTestU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdAntiFreezeBase, IdAntiFreeze, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, IdHTTP, StdCtrls, ExtCtrls,
  photozou_api, ComCtrls, OleCtrls, SHDocVw, csvDb;

type
  TForm1 = class(TForm)
    IdAntiFreeze1: TIdAntiFreeze;
    Panel1: TPanel;
    Label2: TLabel;
    edtMail: TEdit;
    edtPassword: TEdit;
    Label1: TLabel;
    Label3: TLabel;
    btnNop: TButton;
    memo: TMemo;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    btnPhotoAlbum: TButton;
    edtUserId: TEdit;
    btnPhotoAlbumCsv: TButton;
    Label4: TLabel;
    btnUserGroup: TButton;
    btnUserGroupAsCsv: TButton;
    TabSheet3: TTabSheet;
    Label5: TLabel;
    edtFilename: TEdit;
    btnSelectFile: TButton;
    Label6: TLabel;
    edtAlbumId: TEdit;
    Label7: TLabel;
    edtPhotoTitle: TEdit;
    dlgOpen: TOpenDialog;
    btnUploadPhoto: TButton;
    TabSheet4: TTabSheet;
    btn_photo_add_tag: TButton;
    Label8: TLabel;
    edt_tag_user_id: TEdit;
    Label9: TLabel;
    edt_tag_photo_id: TEdit;
    Label10: TLabel;
    edt_tag_tag: TEdit;
    web: TWebBrowser;
    btnBack: TButton;
    procedure FormCreate(Sender: TObject);
    procedure edtMailChange(Sender: TObject);
    procedure btnNopClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnPhotoAlbumClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure btnPhotoAlbumCsvClick(Sender: TObject);
    procedure btnUserGroupClick(Sender: TObject);
    procedure btnUserGroupAsCsvClick(Sender: TObject);
    procedure btnSelectFileClick(Sender: TObject);
    procedure btnUploadPhotoClick(Sender: TObject);
    procedure btn_photo_add_tagClick(Sender: TObject);
    procedure btnBackClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    FApi: TPhotozouApi;
  end;

var
  Form1: TForm1;

function apppath: string;

implementation

{$R *.dfm}

function apppath: string;
begin
  Result := ExtractFilePath(ParamStr(0));
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FApi := TPhotozouApi.Create(self);
end;

procedure TForm1.edtMailChange(Sender: TObject);
begin
  FApi.UserAddress  := edtMail.Text;
  FApi.UserPassword := edtPassword.Text;
end;

procedure TForm1.btnNopClick(Sender: TObject);
begin
  FApi.UseProxyIESetting;
  if FApi.CheckAuth then
  begin
    ShowMessage('Auth OK!');
  end else
  begin
    ShowMessage('Auth failed...');
  end;
  FApi.DisconnectSocket;
end;

procedure TForm1.FormShow(Sender: TObject);
var
  res: string;
  csv: TCsvDb;
begin
  edtMailChange(nil);
    //===
  {
  res := FApi.api_photo_album(0);
  csv := TCsvDb.Create;
  csv.Text := xml2csv(res, 'album','album_id,name');
  memo.Text := csv.Text;
  csv.Free;
  }
end;

procedure TForm1.btnPhotoAlbumClick(Sender: TObject);
var
  html, xml: string;
  csv: TCsvDb;
  i: Integer;
begin
  xml := FApi.api_photo_album(StrToIntDef(edtUserId.Text,0));
  memo.Lines.Text := xml;
  csv := TCsvDb.Create;
  csv.Text := xml2csv(xml, 'album','album_id,user_id,name');
  html := '<html><body>';
  for i := 0 to csv.Count - 1 do
  begin
    html := html +
      format(
        '<a href="http://photozou.jp/photo/list/%s/%s">%s</a><br>',
        [
          csv.Cells[1,i],
          csv.Cells[0,i],
          csv.Cells[2,i]
        ]
      );
  end;
  csv.Free;
  html := html + '</body></html>';
  savetofile(apppath+'test.html', html);
  web.Navigate(apppath+'test.html');
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  FApi.DisconnectSocket;
end;

procedure TForm1.btnPhotoAlbumCsvClick(Sender: TObject);
begin
  memo.Lines.Text := FApi.GetPhotoAlbumList(StrToIntDef(edtUserId.Text,0));
end;

procedure TForm1.btnUserGroupClick(Sender: TObject);
begin
  memo.Lines.Text := FApi.api_user_group;
end;

procedure TForm1.btnUserGroupAsCsvClick(Sender: TObject);
begin
  memo.Lines.Text := FApi.GetUserGroupList;
end;

procedure TForm1.btnSelectFileClick(Sender: TObject);
begin
  if not dlgOpen.Execute then Exit;
  edtFilename.Text := dlgOpen.FileName;
end;

procedure TForm1.btnUploadPhotoClick(Sender: TObject);
begin
  btnUploadPhoto.Enabled := False;
  try
    if edtFilename.Text = '' then
    begin
      ShowMessage('no filename');
      Exit;
    end;
    if FApi.UploadPhoto(edtFilename.Text, StrToIntDef(edtAlbumId.Text, -1), edtPhotoTitle.Text) then
    begin
      ShowMessage('success!');
    end else
    begin
      ShowMessage(FApi.ErrorMessage);
    end;
  finally
    btnUploadPhoto.Enabled := True;
  end;
end;

procedure TForm1.btn_photo_add_tagClick(Sender: TObject);
var
  b: Boolean;
begin
  btn_photo_add_tag.Enabled := False;
  try
    b := FApi.PhotoAddTag(
      StrToIntDef(edt_tag_user_id.Text,0),
      StrToIntDef(edt_tag_photo_id.Text,0),
      edt_tag_tag.Text
    );
  except
    b := False;
  end;
  btn_photo_add_tag.Enabled := True;
  if b then
  begin
    ShowMessage('successed!');
  end else
  begin
    ShowMessage('failed.');
  end;
end;

procedure TForm1.btnBackClick(Sender: TObject);
begin
  web.GoBack;
end;

end.
