unit unit_i18n;

interface

uses
  Windows, SysUtils, Classes;


function SetLanguageCode(code: string): Boolean;
function GetLanguageCode: string;
function GetLanguageFile(code: string): string;
function GetMsg(msg: string; default: string): string;

implementation

uses unit_string;

var
  FLanguageCode: string = 'ja';
  FMsg: TStringList = nil;

function GetMsg(msg: string; default: string): string;
var
  i: Integer;
  s, fname: string;
begin
  if FMsg = nil then
  begin
    FMsg := TStringList.Create;
  end;
  // load
  if FMsg.Count = 0 then
  begin
    try
      fname := getLanguageFile(FLanguageCode);
      if FileExists(fname) then
      begin
        FMsg.LoadFromFile(fname);
      end;
    except
    end;
  end;
  // find
  i := FMsg.IndexOfName(msg);
  if i >= 0 then
  begin
    s := FMsg.Strings[i];
    getToken_s(s, '=');
    s := JReplace(s, '\n', #13#10);
    s := JReplace(s, '\t', #9);
    s := JReplace(s, '\\', '\');
    Result := s;
  end else
  begin
    Result := default;
  end;
end;

function GetLanguageCode: string;
begin
  Result := FLanguageCode;
end;

function SetLanguageCode(code: string): Boolean;
var
  f: string;
begin
  f := GetLanguageFile(code);
  if FileExists(f) then
  begin
    Result := True;
    FLanguageCode := code;
  end else
  begin
    Result := False;
  end;
  if FMsg <> nil then FMsg.Clear;
end;

function GetLanguageFile(code: string): string;
begin
  Result := ExtractFilePath(ParamStr(0)) + 'language\' + code + '\msg.txt';
end;


initialization

finalization
  FreeAndNil(FMsg);

end.
